/*
 * Main.java
 *
 * Created on July 30, 2007, 3:32 PM
 *
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package caverncamuploader;

import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.image.*;

import com.sun.image.codec.jpeg.*; 

/**
 *
 * @author  Robert The Rebuilder
 */
public class Main extends javax.swing.JFrame
{
    
    private PropertiesForm _propertiesForm = null;
    private WebSiteCreatorForm _creatorForm = null;
    private FtpUploadThread _ftpThread = null;
    private boolean _bFirstTimeRun = false;
    
    /** Creates new form Main */
    public Main()
    {
        initComponents();
                       
        // Initialize the properties
        CCUProperties.instance().read();
        enableFields();
    }
    
    public void checkProperties()
    {
        if (!CCUProperties.instance().isComplete())
        {
            _bFirstTimeRun = true;
            this._settingsMenuItemActionPerformed(null);
        }
        else
        {
            this._uploadingToggleButton.setEnabled(true);
            setVisible(true);
        }
    }
    
    public void dispose()
    {
        // Clean up the FTP class
        if (this._ftpThread != null)
        {
            this._ftpThread.interrupt();
        }
        if (this._propertiesForm != null)
        {
            this._propertiesForm.dispose();
        }
        if (this._creatorForm != null)
        {
            this._creatorForm.dispose();
        }
        System.exit(0);
    }
 
    public void showError(String errorType, String errorMessage)
    {
        javax.swing.JOptionPane.showMessageDialog(this,errorMessage,errorType,javax.swing.JOptionPane.ERROR_MESSAGE);
        enableFields();
    }
    
    public void enableFields()
    {
        this._uploadingToggleButton.setSelected(false);
        this._uploadingToggleButton.setText("Start Uploading");
        this._uploadingToggleButton.setEnabled(true);
        this._settingsMenuItem.setEnabled(true);
        this._webPageCreatorItem.setEnabled(true);
        this._uploadAwayImageItem.setEnabled(CCUProperties.instance().getAwayImageProperty() != null);
    }
    
    public void onFtpThreadFinished()
    {
        enableFields();
        
        java.awt.Cursor cursor = new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR);
        setCursor(cursor);
        _ftpThread = null;
    }
    
    private void onPropertyWindowClosed()
    {
        _propertiesForm = null;
        this._settingsMenuItem.setEnabled(true);
        
        // Check whether the properties have all the necessary values
        this._uploadingToggleButton.setEnabled(CCUProperties.instance().isComplete());
        this._uploadAwayImageItem.setEnabled(CCUProperties.instance().getAwayImageProperty() != null);
        setVisible(true);
        
        if (_bFirstTimeRun)
        {
            _bFirstTimeRun = false;
            if (javax.swing.JOptionPane.showConfirmDialog(this,"Do you want to create and upload your CavernCam web page now?") == javax.swing.JOptionPane.OK_OPTION)
            {
                this._webPageCreatorItemActionPerformed(null);
            }
        }
    }
    
    private void onCreatorWindowClosed()
    {
        _creatorForm = null;
        setVisible(true);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        _uploadingToggleButton = new javax.swing.JToggleButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        _settingsMenuItem = new javax.swing.JMenuItem();
        _exitMenuItem = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        _webPageCreatorItem = new javax.swing.JMenuItem();
        _showFtpMessagesItem = new javax.swing.JCheckBoxMenuItem();
        _uploadAwayImageItem = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        _howToItem = new javax.swing.JMenuItem();
        _aboutItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("CavernCam Uploader");
        _uploadingToggleButton.setText("Start Uploading");
        _uploadingToggleButton.setEnabled(false);
        _uploadingToggleButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _uploadingToggleButtonActionPerformed(evt);
            }
        });

        jMenu1.setText("File");
        _settingsMenuItem.setText("Settings...");
        _settingsMenuItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _settingsMenuItemActionPerformed(evt);
            }
        });

        jMenu1.add(_settingsMenuItem);

        _exitMenuItem.setText("Exit");
        _exitMenuItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _exitMenuItemActionPerformed(evt);
            }
        });

        jMenu1.add(_exitMenuItem);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Tools");
        _webPageCreatorItem.setText("Web Page Creator");
        _webPageCreatorItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _webPageCreatorItemActionPerformed(evt);
            }
        });

        jMenu2.add(_webPageCreatorItem);

        _showFtpMessagesItem.setText("Show FTP Messages");
        _showFtpMessagesItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _showFtpMessagesItemActionPerformed(evt);
            }
        });

        jMenu2.add(_showFtpMessagesItem);

        _uploadAwayImageItem.setText("Upload Away Image");
        _uploadAwayImageItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _uploadAwayImageItemActionPerformed(evt);
            }
        });

        jMenu2.add(_uploadAwayImageItem);

        jMenuBar1.add(jMenu2);

        jMenu3.setText("Help");
        _howToItem.setText("How do I...?");
        _howToItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _howToItemActionPerformed(evt);
            }
        });

        jMenu3.add(_howToItem);

        _aboutItem.setText("About");
        _aboutItem.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _aboutItemActionPerformed(evt);
            }
        });

        jMenu3.add(_aboutItem);

        jMenuBar1.add(jMenu3);

        setJMenuBar(jMenuBar1);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(63, 63, 63)
                .add(_uploadingToggleButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 166, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(63, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(27, 27, 27)
                .add(_uploadingToggleButton)
                .addContainerGap(31, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void _uploadAwayImageItemActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__uploadAwayImageItemActionPerformed
    {//GEN-HEADEREND:event__uploadAwayImageItemActionPerformed
        String awayImageName = CCUProperties.instance().getAwayImageProperty();
        if (awayImageName == null)
        {
            javax.swing.JOptionPane.showMessageDialog(this,"Please specify an away image on the Settings form.");
            this._uploadAwayImageItem.setEnabled(false);
            return;
        }
        File awayFile = new File(awayImageName);
        if (!awayFile.exists())
        {
            
            javax.swing.JOptionPane.showMessageDialog(this,"Could not locate away image " + awayFile.getAbsolutePath() + ".\nPlease choose another image on the Settings form.");
            return;
        }
        
        
        Linlyn ftp = null;
        java.awt.Cursor hourglassCursor = new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR);
        setCursor(hourglassCursor);
        
        // Load the file into memory
        DataInputStream dataInputStream = null;
        byte [] bytes = null;
        try
        {
            dataInputStream = new DataInputStream(new FileInputStream(awayFile));
            bytes = new byte[dataInputStream.available()];
            dataInputStream.read(bytes);
            dataInputStream.close();
            dataInputStream = null;
        }
        catch (Exception ex)
        {
            javax.swing.JOptionPane.showMessageDialog(this,
                    "Could not load the image file."+ex.getMessage(),
                    "File Error",
                    javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        String ftpSite = CCUProperties.instance().getFtpSite();
        String username = CCUProperties.instance().getUsername();
        String password = CCUProperties.instance().getPassword();
        String ftpDir = CCUProperties.instance().getCavernCamDir();
        String uploadFileName = "image.jpg";
        while (true)
        {
            // Attempt to connect
            try
            {
                ftp = new Linlyn(ftpSite,username,password);
            }
            catch (Exception ex)
            {
                if (Linlyn.DEBUG)
                {
                    System.out.println(ex.toString());
                }
                javax.swing.JOptionPane.showMessageDialog(this,
                        "Could not log in to the FTP site.  Check that the following is correct:\n\t- FTP Site\n\t- Username\n\t- Password\n" +
                        "Also check whether your connection is still active.",
                        "FTP Error",
                        javax.swing.JOptionPane.ERROR_MESSAGE);
                break;
            }
            
            
            // Go to the correct directory
            try
            {
                ftp.ftpSetDir(ftpDir);
            }
            catch (Exception ex)
            {
                if (Linlyn.DEBUG)
                {
                    System.out.println(ex.toString());
                }
                javax.swing.JOptionPane.showMessageDialog(this,
                        "Could not change to the directory \"" + ftpDir + " on the FTP site.",
                        "FTP Error",
                        javax.swing.JOptionPane.ERROR_MESSAGE);
                break;
            }
            
            // Attempt to upload the image
            try
            {
                ftp.upload(null,uploadFileName,bytes,false);
                bytes = null;
            }
            catch (Exception ex)
            {
                javax.swing.JOptionPane.showMessageDialog(this,
                        "Could not upload image to the CavernCam Directory on the FTP site.",
                        "FTP Error",
                        javax.swing.JOptionPane.ERROR_MESSAGE);
                break;
            }
            
            break;
        }
        
        if (ftp != null)
        {
            // Attempt to clean up
            try
            {
                ftp.Logout();
            }
            catch (Exception ex)
            {
                // Not sure what the value is in announcing an error upon logout
            }
            ftp = null;
        }
        ftp = null;
        
        java.awt.Cursor cursor = new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR);
        setCursor(cursor);
        
    }//GEN-LAST:event__uploadAwayImageItemActionPerformed

    private void _aboutItemActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__aboutItemActionPerformed
    {//GEN-HEADEREND:event__aboutItemActionPerformed
        javax.swing.JOptionPane.showMessageDialog(this,"This software is protected under the 2007 GNU General Public License.\n\n" +
                "Version: " + CCUProperties.instance()._versionString + "\n\n" +
                "Developed by:\n\n" +
                "\tRobert The Rebuilder\n" +
                "\tHerohtar\n\n");
    }//GEN-LAST:event__aboutItemActionPerformed

    private void _uploadingToggleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__uploadingToggleButtonActionPerformed
    {//GEN-HEADEREND:event__uploadingToggleButtonActionPerformed

        // Detect whether the button is in (start) or out (stop)
        if (this._uploadingToggleButton.isSelected())
        {
            // Check whether the password exists
            if (CCUProperties.instance().getPassword() == null)
            {
                String password = javax.swing.JOptionPane.showInputDialog(this,"Please enter a password for your FTP account:","Need FTP Password",javax.swing.JOptionPane.INFORMATION_MESSAGE);
                if (password == null || password.trim().length() == 0)
                {
                    javax.swing.JOptionPane.showMessageDialog(this,"No password was specified - aborting upload.");
                    this._uploadingToggleButton.setSelected(false);
                    return;
                }
                CCUProperties.instance().setPassword(password);
            }
            this._uploadingToggleButton.setText("Stop Uploading");
            this._settingsMenuItem.setEnabled(false);
            this._webPageCreatorItem.setEnabled(false);
            
            // Spawn the uploading thread
            _ftpThread = new FtpUploadThread(this);
            _ftpThread.start();
        }
        else
        {
            java.awt.Cursor hourglassCursor = new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR);
            setCursor(hourglassCursor);
            this._uploadingToggleButton.setEnabled(false);
            
            // Request the FTP thread to stop
            if (_ftpThread != null)
            {
                _ftpThread.requestStop();
            }
            
        }
    }//GEN-LAST:event__uploadingToggleButtonActionPerformed

    private void _howToItemActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__howToItemActionPerformed
    {//GEN-HEADEREND:event__howToItemActionPerformed
        javax.swing.JOptionPane.showMessageDialog(this,"For instructions on running this application, visit:\n\n" +
                "http://www.bergen-hill.com/rtr/CavernCamera/howto.html\n\n" +
                "For technical issues, please email me at:\n\n" +
                "robert.the.rebuilder@hotmail.com",
                "Help Information",
                javax.swing.JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event__howToItemActionPerformed

    private void _showFtpMessagesItemActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__showFtpMessagesItemActionPerformed
    {//GEN-HEADEREND:event__showFtpMessagesItemActionPerformed
        Linlyn.DEBUG = this._showFtpMessagesItem.isSelected();
    }//GEN-LAST:event__showFtpMessagesItemActionPerformed

    private void _webPageCreatorItemActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__webPageCreatorItemActionPerformed
    {//GEN-HEADEREND:event__webPageCreatorItemActionPerformed
        if (this._creatorForm == null)
        {
            this._creatorForm = new WebSiteCreatorForm();
            _creatorForm.addWindowListener(new WindowAdapter()
            {
                public void windowClosed(WindowEvent e)
                {
                    onCreatorWindowClosed();
                }
            });
        }
        this._creatorForm.setVisible(true);
    }//GEN-LAST:event__webPageCreatorItemActionPerformed

    private void _exitMenuItemActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__exitMenuItemActionPerformed
    {//GEN-HEADEREND:event__exitMenuItemActionPerformed
        this.dispose();
    }//GEN-LAST:event__exitMenuItemActionPerformed

    private void _settingsMenuItemActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__settingsMenuItemActionPerformed
    {//GEN-HEADEREND:event__settingsMenuItemActionPerformed
        if (_propertiesForm == null)
        {
            _propertiesForm = new PropertiesForm();
            _propertiesForm.addWindowListener(new WindowAdapter()
            {
                public void windowClosed(WindowEvent e)
                {
                    onPropertyWindowClosed();
                }
            });
            this._uploadingToggleButton.setEnabled(false);
        }
        _propertiesForm.setVisible(true);
    }//GEN-LAST:event__settingsMenuItemActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            public void run()
            {
                Main mainForm = new Main();
                mainForm.checkProperties();
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem _aboutItem;
    private javax.swing.JMenuItem _exitMenuItem;
    private javax.swing.JMenuItem _howToItem;
    private javax.swing.JMenuItem _settingsMenuItem;
    private javax.swing.JCheckBoxMenuItem _showFtpMessagesItem;
    private javax.swing.JMenuItem _uploadAwayImageItem;
    private javax.swing.JToggleButton _uploadingToggleButton;
    private javax.swing.JMenuItem _webPageCreatorItem;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenuBar jMenuBar1;
    // End of variables declaration//GEN-END:variables
    
    
    private class MyWindowStateListener extends WindowAdapter
    {
        public void windowClosed(WindowEvent e)
        {
            onPropertyWindowClosed();
        }
    }
    
}
