/*
 * ScreenCapture.java
 *
 * Created on July 31, 2007, 2:52 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package caverncamuploader;

import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import com.sun.image.codec.jpeg.*; 
import javax.swing.*; 

/**
 *
 * @author Herohtar
 */
public class ScreenCapture { 
   public ScreenCapture() {} 
    
   /** 
    * 
    * @param quality     The quality of the JPEG 
    * @param filename    The file to save the capture to 
    */ 
   public void capture(Float quality, String filename, int leftX, int topY, int width, int height) { 
      try { 
         // Create the output file 
         File screenshotFile = new File(filename); 
         FileOutputStream outFile = new FileOutputStream(screenshotFile); 
         
         capture(quality,outFile,leftX,topY,width,height);
         
         outFile.close(); 
      } catch (IOException e) { 
         System.out.println(e); 
      } 
   } 
   /** 
    * 
    * @param quality     The quality of the JPEG 
    * @param outputStream    The stream to save the capture to 
    */ 
   public void capture(Float quality, OutputStream outputStream, int leftX, int topY, int width, int height) { 
      try { 
         // Find the screen size and create the capture rectangle 
         Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(); 
         if (screenSize.width > width)
             screenSize.width = width;
         if (screenSize.height > height)
             screenSize.height = height;
         Rectangle capRect = new Rectangle(new Point(leftX,topY),screenSize); 
          
         // Create the screen capture device 
         Robot robot = new Robot(); 
          
         // Capture the image 
         BufferedImage image = robot.createScreenCapture(capRect); 
          
         // Encode the image as a JPEG and save it to the specified file 
         JPEGImageEncoder snapEncoder = JPEGCodec.createJPEGEncoder(outputStream); 
         JPEGEncodeParam param = snapEncoder.getDefaultJPEGEncodeParam(image); 
         param.setQuality(quality, false); 
         snapEncoder.setJPEGEncodeParam(param); 
         snapEncoder.encode(image); 
      } catch (IOException e) { 
         System.out.println(e); 
      } catch (AWTException ae) { 
         System.out.println(ae); 
      } 
   } 
}
