/*
 * WebSiteCreatorForm.java
 *
 * Created on July 30, 2007, 6:13 PM
 *
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package caverncamuploader;

import java.io.*;

/**
 *
 * @author  TBERGENHILL
 */
public class WebSiteCreatorForm extends javax.swing.JFrame
{
    
    private FtpThread _ftpThread = null;
    private String _webSiteUrl = CCUProperties.instance().getWebSiteUrlProperty();
    private String _webSiteTitle = CCUProperties.instance().getWebSiteTitleProperty();
    private int _refreshInterval = 5;
    private boolean _bIncludeLinks = CCUProperties.instance().getIncludeLinksProperty().equalsIgnoreCase("true");
    
    private final String _appletFileName = "CavernCamApplet.class";
    
    /** Creates new form WebSiteCreatorForm */
    public WebSiteCreatorForm()
    {
        initComponents();
        
        this._refreshIntervalTextField.setText(CCUProperties.instance().getRefreshIntervalProperty());
        this._webSiteUrlTextField.setText(_webSiteUrl);
        this._webSiteTitleTextField.setText(_webSiteTitle);
    }
    
    
    public void showError(String errorType, String errorMessage)
    {
        javax.swing.JOptionPane.showMessageDialog(this,errorMessage,errorType,javax.swing.JOptionPane.ERROR_MESSAGE);
        if (_ftpThread != null)
        {
            _ftpThread.requestStop();
            _ftpThread = null;
        }
    }
    
    public void onFtpThreadFinished(boolean bSuccessful)
    {
        //enableFields();
        
        java.awt.Cursor hourglassCursor = new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR);
        setCursor(hourglassCursor);
        _ftpThread = null;
        
        if (bSuccessful)
        {
            javax.swing.JOptionPane.showMessageDialog(this,"Your web page successfully uploaded.");
            this.dispose();
        }
    }
    
    public void dispose()
    {
        // Clean up the FTP class
        if (this._ftpThread != null)
        {
            this._ftpThread.interrupt();
            _ftpThread = null;
        }
        super.dispose();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        jLabel1 = new javax.swing.JLabel();
        _webSiteUrlTextField = new javax.swing.JTextField();
        _uploadButton = new javax.swing.JButton();
        _cancelButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        _webSiteTitleTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        _refreshIntervalTextField = new javax.swing.JTextField();
        _includeLinksCheckBox = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Web Site Creator");
        jLabel1.setText("CavernCam Web Site URL:");

        _uploadButton.setText("Create And Upload");
        _uploadButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _uploadButtonActionPerformed(evt);
            }
        });

        _cancelButton.setText("Cancel");
        _cancelButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                _cancelButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("Web Site Title:");

        jLabel3.setText("Refresh Interval (Seconds):");

        _includeLinksCheckBox.setSelected(true);
        _includeLinksCheckBox.setText("Include links to setup instructions and CavernCam Community");
        _includeLinksCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        _includeLinksCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(_uploadButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 258, Short.MAX_VALUE)
                        .add(_cancelButton))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel1)
                            .add(jLabel2))
                        .add(14, 14, 14)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(_webSiteUrlTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 304, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, _refreshIntervalTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 42, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, _webSiteTitleTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 304, Short.MAX_VALUE)))
                    .add(jLabel3)
                    .add(_includeLinksCheckBox))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(_webSiteUrlTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel2)
                    .add(_webSiteTitleTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(_refreshIntervalTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(_includeLinksCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 30, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(_uploadButton)
                    .add(_cancelButton))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void _cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__cancelButtonActionPerformed
    {//GEN-HEADEREND:event__cancelButtonActionPerformed
        
            // Request the FTP thread to stop
        if (_ftpThread != null)
        {
            java.awt.Cursor hourglassCursor = new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR);
            setCursor(hourglassCursor);
            _ftpThread.requestStop();
        }
        else
        {
            this.dispose();
        }
    }//GEN-LAST:event__cancelButtonActionPerformed
    
    private void _uploadButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event__uploadButtonActionPerformed
    {//GEN-HEADEREND:event__uploadButtonActionPerformed
        // Check that the URL is not empty
        this._webSiteUrl = this._webSiteUrlTextField.getText();
        if (_webSiteUrl == null || _webSiteUrl.trim().length() == 0)
        {
            javax.swing.JOptionPane.showMessageDialog(this,"Please specify a web site URL.");
            return;
        }
        CCUProperties.instance().setWebSiteUrlProperty(_webSiteUrl);
        
        // Check that the title is not empty
        this._webSiteTitle = this._webSiteTitleTextField.getText();
        if (_webSiteTitle == null || _webSiteTitle.trim().length() == 0)
        {
            javax.swing.JOptionPane.showMessageDialog(this,"Please specify a title for your web site.");
            return;
        }
        CCUProperties.instance().setWebSiteTitleProperty(this._webSiteTitle);
        
        // Check that the refresh interval is valid
        String temp = this._refreshIntervalTextField.getText();
        if (temp == null || temp.trim().length() == 0)
        {
            javax.swing.JOptionPane.showMessageDialog(this,"Please specify a refresh interval.");
            return;
        }
        int tempInt = 0;
        try
        {
            tempInt = Integer.parseInt(temp);
        }
        catch (Exception ex)
        {
            javax.swing.JOptionPane.showMessageDialog(this,"The value of \"" + temp + "\" is not valid.  Please specify a valid refresh interval.");
            return;
        }
        if (tempInt <= 0)
        {
            javax.swing.JOptionPane.showMessageDialog(this,"Please specify a refresh interval that is greater than zero.");
            return;
        }
        this._refreshInterval = tempInt;
        CCUProperties.instance().setRefreshIntervalProperty(temp);
        
        this._bIncludeLinks = this._includeLinksCheckBox.isSelected();
        CCUProperties.instance().setIncludeLinksProperty((this._bIncludeLinks) ? "true":"false");
        
        CCUProperties.instance().write();
        
        // Obtain the password
        if (CCUProperties.instance().getPassword() == null)
        {
            String password = javax.swing.JOptionPane.showInputDialog(this,"Please enter a password for your FTP account:","Need FTP Password",javax.swing.JOptionPane.INFORMATION_MESSAGE);
            if (password == null || password.trim().length() == 0)
            {
                javax.swing.JOptionPane.showMessageDialog(this,"No password was specified - aborting upload.");
                return;
            }
            CCUProperties.instance().setPassword(password);
        }
        
        java.awt.Cursor hourglassCursor = new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR);
        setCursor(hourglassCursor);
        
        // Spawn the uploading thread
        _ftpThread = new FtpThread();
        _ftpThread.start();
    }//GEN-LAST:event__uploadButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton _cancelButton;
    private javax.swing.JCheckBox _includeLinksCheckBox;
    private javax.swing.JTextField _refreshIntervalTextField;
    private javax.swing.JButton _uploadButton;
    private javax.swing.JTextField _webSiteTitleTextField;
    private javax.swing.JTextField _webSiteUrlTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    // End of variables declaration//GEN-END:variables
    
    private class FtpThread extends Thread
    {
        private final String _uploadFileName = "image.jpg";
        private final String _uploadDateName = "date.txt";
        private final int _sleepDuration = 500; // milliseconds
        
        private boolean _shouldIStop = false;
        private String _ftpSite = CCUProperties.instance().getFtpSite();
        private String _username = CCUProperties.instance().getUsername();
        private String _password = CCUProperties.instance().getPassword();
        private String _ftpDir = CCUProperties.instance().getCavernCamDir();
        private String _matchSubstring = CCUProperties.instance().getMatchingSubstring();
        private String _imageType = CCUProperties.instance().getImageType();
        private String _localImageDir = CCUProperties.instance().getLocalImageDir();
        private String _imageWidth = CCUProperties.instance().getImageWidth();
        private String _imageHeight = CCUProperties.instance().getImageHeight();
        private boolean _bUploadDate = CCUProperties.instance().getUploadImageDate().equalsIgnoreCase("true");
        
        public void run()
        {
            Linlyn ftp = null;
            boolean bSuccessful = false;
            
            while (true)
            {
                // Attempt to connect
                try
                {
                    ftp = new Linlyn(_ftpSite,_username,_password);
                }
                catch (Exception ex)
                {
                    if (Linlyn.DEBUG)
                    {
                        System.out.println(ex.toString());
                    }
                    java.awt.EventQueue.invokeLater(new Runnable()
                    {
                        public void run()
                        {
                            showError("FTP Error","Could not log in to the FTP site.  Check that the following is correct:\n\t- FTP Site\n\t- Username\n\t- Password\n" +
                                    "Also check whether your connection is still active.");
                        }
                    });
                    break;
                }
                
                // Go to the correct directory
                try
                {
                    ftp.ftpSetDir(_ftpDir);
                }
                catch (Exception ex)
                {
                    if (Linlyn.DEBUG)
                    {
                        System.out.println(ex.toString());
                    }
                    java.awt.EventQueue.invokeLater(new ShowErrorRunnable("FTP Error",
                            "Could not change to the directory \"" + _ftpDir + " on the FTP site."));
                    break;
                }
                
                // Load the applet class file into memory
                byte [] bytes = null;
                try
                {
                    File candidateFile = new File(CCUProperties.instance().getFullPath() + File.separatorChar + 
                            "CavernCamApplet" + File.separatorChar + _appletFileName);
                    if (!candidateFile.exists())
                    {
                        java.awt.EventQueue.invokeLater(new ShowErrorRunnable("File Error","Could not find the applet file "+candidateFile.getAbsolutePath()));
                        break;
                    }
                    DataInputStream dataInputStream = new DataInputStream(new FileInputStream(candidateFile));
                    bytes = new byte[dataInputStream.available()];
                    dataInputStream.read(bytes);
                    dataInputStream.close();
                    dataInputStream = null;
                }
                catch (Exception ex)
                {
                    java.awt.EventQueue.invokeLater(new ShowErrorRunnable("File Error","Could not load the applet. "+ex.getMessage()));
                    break;
                }
                
                // Upload the applet class
                try
                {
                    ftp.upload(null,_appletFileName,bytes,false);
                    bytes = null;
                }
                catch (Exception ex)
                {
                    if (Linlyn.DEBUG)
                    {
                        System.out.println(ex.toString());
                    }
                    java.awt.EventQueue.invokeLater(new ShowErrorRunnable("FTP Error",
                            "Could not upload applet to the CavernCam Directory on the FTP site."));
                    break;
                }
                
                // take a break in between
                try
                {
                    this.sleep(500);
                }
                catch (Exception ex)
                {
                    // Interruption - we should stop
                    break;
                }
                
                // Generate the index.html text string
                String dateString = (this._bUploadDate) ? "<param name=\"dateURL\" value=\"" +_webSiteUrl+ "/date_image.jpg\">\n":"\n";
                String linkString = (_bIncludeLinks) ? "<P><a href=http://www.bergen-hill.com/rtr/CavernCam/howto.html>Learn</a> how to do this yourself, then join the <a href=http://www.bergen-hill.com/rtr/CavernCam/ccc.html>CameraCam Community</a>!<P>":"<P>\n";
                String indexHtmlString = "<html>\n" +
                        "<head>\n" +
                        "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n" +
                        "<title>" + _webSiteTitle + "</title>\n" +
                        "</head>\n" +
                        "<body bgcolor=\"#000000\" text=\"#ffffff\" STYLE=\"background-color:#000000; OVERFLOW: hidden;\">\n" +
                        "<h2><center>" + _webSiteTitle + "</center></h2>\n" +
                        linkString +
                        "<hr>\n" +
                        "<table border=\"0\" cellspacing=\"0\" cellpadding=\"4\"><tbody>\n" +
                        "<tr><td valign=\"top\" halign=\"center\" width=\"" + _imageWidth + "\" height=\"" + _imageHeight + "\">\n" +
                        "<applet code=\"CavernCamApplet.class\" align=\"baseline\" width=\"" + _imageWidth + "\" height=\"" + _imageHeight + "\">\n" +
                        "<param name=\"URL\" value=\"" +_webSiteUrl+ "/image.jpg\">\n" +
                        dateString +
                        "<param name=\"Seconds\" value=\"" + String.valueOf(_refreshInterval) + "\">\n" +
                        "<param name=\"width\" value=\"" + _imageWidth + "\">\n" +
                        "<param name=\"height\" value=\"" + _imageHeight + "\">\n" +
                        "</applet>\n" +
                        "</td></tr></tbody></table><hr>\n" +
                        "<center><a href=http://www.mystonline.com>Myst Online : Uru Live</a>(TM) is the sole property of Cyan Worlds Inc. Copyright 2003 Cyan Worlds, Inc. All Rights reserved. Used with Permission.</center>\n" +
                        "</body></html>";
                
                
                // Attempt to upload the index.html
                try
                {
                    ftp.upload(null,"index.html",indexHtmlString.getBytes(),true);
                    bytes = null;
                }
                catch (Exception ex)
                {
                    if (Linlyn.DEBUG)
                    {
                        System.out.println(ex.toString());
                    }
                    java.awt.EventQueue.invokeLater(new Runnable()
                    {
                        public void run()
                        {
                            showError("FTP Error","Could not upload index.html to the CavernCam Directory on the FTP site.");
                        }
                    });
                    break;
                }
                
                // Do some much-needed garbage collection
                System.gc();
                bSuccessful = true;
                break;
            }
            

            // Attempt to clean up
            try
            {
                ftp.Logout();
            }
            catch (Exception ex)
            {
                // Not sure what the value is in announcing an error upon logout
            }
            ftp = null;
            
            // Notify the main thread
            java.awt.EventQueue.invokeLater(new FtpThreadFinished(bSuccessful));
        }
        
        public synchronized void requestStop()
        {
            _shouldIStop = true;
        }
        
        public synchronized boolean shouldIStop()
        {
            return _shouldIStop;
        }
        
    }
    
    private class FtpThreadFinished implements Runnable
    {
        boolean bSuccessful = false;
        public FtpThreadFinished(boolean value)
        {
            bSuccessful = value;
        }
        
        public void run()
        {
            onFtpThreadFinished(bSuccessful);
        }
    }
    
    private class ShowErrorRunnable implements Runnable
    {
        String _errorType = null;
        String _errorMessage = null;
        public ShowErrorRunnable(String errorType, String errorMessage)
        {
            _errorType = errorType;
            _errorMessage = errorMessage;
        }
        
        public void run()
        {
            showError(_errorType,_errorMessage);
        }
    }
}
